﻿namespace ClusterBombShockwave
{
    using System;
    using System.Windows.Forms;
    using System.Drawing;
    using GTA;
    using GTA.Native;

    public class Main : Script
    {
        const float POWER = 2f;
        GTA.Object mainBomb;
        GTA.Object[] cluster = new GTA.Object[8];
        Light[] nadeLights = new Light[8];
        Checkpoint nuke;
        Light nukeLight;
        bool trigger;
        Vector3 nukePosition;
        Model nadeModel = new Model(0x63A855E9);
        GTA.Timer timer1;
        Camera skyCam;

        public Main()
        {
            BindKey(Keys.T, TriggerNuke);
            BindKey(Keys.Tab, SkyCam);
            nuke = new Checkpoint(Vector3.Zero, Color.WhiteSmoke, 5f);
            nukeLight = new Light(Color.WhiteSmoke, 5f, 250f, Vector3.Zero);
            nuke.Disable();

            timer1 = new GTA.Timer(2000);
            timer1.Tick += timer1_Tick;

            skyCam = new Camera();
        }

        void SkyCam()
        {
            if (skyCam.isActive)
            {
                skyCam.Deactivate();
            }
            else if (trigger)
            {
                skyCam.Activate();
            }
        }

        void StopNuke()
        {
            trigger = false;
            if (skyCam.isActive)
            {
                skyCam.Deactivate();
            }
            nuke.Diameter = 5f;
            nukeLight.Range = 5f;
            nuke.Disable();
            nukeLight.Disable();
            Tick -= Main_Tick;
        }

        void TriggerNuke()
        {
            if (trigger) return;

            trigger = true;
            
            bool inCar = Game.LocalPlayer.Character.isInVehicle();

            if (!inCar)
            {
                Game.LocalPlayer.Character.Task.PlayAnimation(new AnimationSet("amb@atm"), "m_getoutwallet_chest", 2.4f, AnimationFlags.Unknown12 | AnimationFlags.Unknown11 | AnimationFlags.Unknown09);
                Wait(100);
            }
            mainBomb = World.CreateObject(nadeModel, Game.LocalPlayer.Character.GetOffsetPosition(new Vector3(0.1f, 0f, 0.2f)));

            while (!Game.Exists(mainBomb)) { Wait(0); }
            mainBomb.Visible = false;

            if (!inCar)
            {
                Pointer objPointer = typeof(GTA.Object);
                objPointer.SetValue(mainBomb);
                Function.Call("SET_OBJECT_AS_STEALABLE", objPointer, 1);
                Function.Call("SET_OBJECT_DYNAMIC", mainBomb, 1);
                Function.Call("TASK_PICKUP_AND_CARRY_OBJECT", Game.LocalPlayer.Character, mainBomb, 0f, 0f, 0f, 0);
                Wait(600);
                mainBomb.Visible = true;
            }
            else
            {
                mainBomb.Visible = true;
                mainBomb.AttachToVehicle(Game.LocalPlayer.Character.CurrentVehicle, new Vector3(-1.1f, 0.3f, 0.4f), Vector3.Zero);
                Wait(300);
                mainBomb.Detach();
            }



            Wait(5000);

            nukePosition = nuke.Position = nukeLight.Position = mainBomb.Position;
            skyCam.Position = nukePosition + Vector3.WorldUp * 200;
            skyCam.LookAt(nukePosition);

            for (int i = 0; i < cluster.Length; i++) { cluster[i] = World.CreateObject(nadeModel, mainBomb.Position.Around(5f)); }
            for (int i = 0; i < cluster.Length; i++) { Function.Call("ATTACH_OBJECT_TO_OBJECT", cluster[i].GetHashCode(), mainBomb.GetHashCode(), true, 0f, 0f, 0f, 0f, 0f, 0f); cluster[i].Detach(); }
            for (int i = 0; i < cluster.Length; i++) { nadeLights[i] = new Light(Color.Red, 2f, 50f, cluster[i].Position); nadeLights[i].Enabled = true; }
            Tick += Light_Tick;
            World.AddExplosion(nukePosition, ExplosionType.Default, 15f, true, false, 0f);
            Wait(50);
            World.AddExplosion(nukePosition, ExplosionType.Default, 15f, true, false, 0f);

            for (int i = 0; i < cluster.Length; i++) { cluster[i].ApplyForce(Vector3.WorldUp + Vector3.Normalize(cluster[i].Position - nukePosition) * 10); }
            mainBomb.Delete();
            timer1.Start();
        }

        void Light_Tick(object sender, EventArgs e)
        {
            for (int i = 0; i < cluster.Length; i++) { nadeLights[i].Position = cluster[i].Position; }
        }

        void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            for (int i = 1; i < cluster.Length; i++) { World.AddExplosion(cluster[i].Position, ExplosionType.Rocket, 20f, true, false, 0f); Wait(100); }

            Tick -= Light_Tick;
            foreach (Light light in nadeLights)
            {
                light.Disable();
            }
            //Add Eight Clusters then another wait, then each cluster explodes then Nuke

            for (int i = 0; i < cluster.Length; i++) { if (Game.Exists(cluster[i])) cluster[i].Delete(); }
            Wait(100);

            nuke.Visible = true;
            nukeLight.Enabled = true;
            Tick += Main_Tick;
        }
        void Main_Tick(object sender, EventArgs e)
        {
            nuke.Diameter += 5f;
            nukeLight.Range = nuke.Diameter;
            //Game.DisplayText("Nuking - " + nuke.Diameter.ToString("n0"));

            float range = nuke.Diameter / 2;
            foreach (Ped ped in World.GetPeds(nukePosition, range + 10f))
            {
                if (!Game.Exists(ped)) continue;
                ped.ForceRagdoll(5000, false);
                ped.ApplyForce((Vector3.Normalize(ped.Position - nukePosition) + new Vector3(0f, 0f, 0.5f)) * POWER);
            }
            foreach (Vehicle veh in World.GetVehicles(nukePosition, range + 5f))
            {
                if (!Game.Exists(veh)) continue;
                veh.ApplyForce((Vector3.Normalize(veh.Position - nukePosition) + new Vector3(0f, 0f, 0.5f)) * POWER);
            }
            foreach (GTA.Object obj in World.GetAllObjects())
            {
                if (!Game.Exists(obj)) continue;
                if (obj.Position.DistanceTo(nukePosition) > range + 5f) continue;
                obj.ApplyForce((Vector3.Normalize(obj.Position - nukePosition) + new Vector3(0f, 0f, 0.5f)) * POWER);
            }

            if (range > 650f) StopNuke();
        }
    }
}
